<!doctype html>
<html class="default no-js">
<head>
	<meta charset="utf-8">
	<meta http-equiv="X-UA-Compatible" content="IE=edge">
	<title>ClientServerInterface | frozen-island-client-core</title>
	<meta name="description" content="">
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<link rel="stylesheet" href="../assets/css/main.css">
</head>
<body>
<header>
	<div class="tsd-page-toolbar">
		<div class="container">
			<div class="table-wrap">
				<div class="table-cell" id="tsd-search" data-index="../assets/js/search.js" data-base="..">
					<div class="field">
						<label for="tsd-search-field" class="tsd-widget search no-caption">Search</label>
						<input id="tsd-search-field" type="text" />
					</div>
					<ul class="results">
						<li class="state loading">Preparing search index...</li>
						<li class="state failure">The search index is not available</li>
					</ul>
					<a href="../index.html" class="title">frozen-island-client-core</a>
				</div>
				<div class="table-cell" id="tsd-widgets">
					<div id="tsd-filter">
						<a href="#" class="tsd-widget options no-caption" data-toggle="options">Options</a>
						<div class="tsd-filter-group">
							<div class="tsd-select" id="tsd-filter-visibility">
								<span class="tsd-select-label">All</span>
								<ul class="tsd-select-list">
									<li data-value="public">Public</li>
									<li data-value="protected">Public/Protected</li>
									<li data-value="private" class="selected">All</li>
								</ul>
							</div>
							<input type="checkbox" id="tsd-filter-inherited" checked />
							<label class="tsd-widget" for="tsd-filter-inherited">Inherited</label>
							<input type="checkbox" id="tsd-filter-externals" checked />
							<label class="tsd-widget" for="tsd-filter-externals">Externals</label>
							<input type="checkbox" id="tsd-filter-only-exported" />
							<label class="tsd-widget" for="tsd-filter-only-exported">Only exported</label>
						</div>
					</div>
					<a href="#" class="tsd-widget menu no-caption" data-toggle="menu">Menu</a>
				</div>
			</div>
		</div>
	</div>
	<div class="tsd-page-title">
		<div class="container">
			<ul class="tsd-breadcrumb">
				<li>
					<a href="../globals.html">Globals</a>
				</li>
				<li>
					<a href="../modules/_clientserverinterface_.html">&quot;clientServerInterface&quot;</a>
				</li>
				<li>
					<a href="_clientserverinterface_.clientserverinterface.html">ClientServerInterface</a>
				</li>
			</ul>
			<h1>Class ClientServerInterface</h1>
		</div>
	</div>
</header>
<div class="container container-main">
	<div class="row">
		<div class="col-8 col-content">
			<section class="tsd-panel tsd-comment">
				<div class="tsd-comment tsd-typography">
					<div class="lead">
						<p>The ClientServerInterface class</p>
					</div>
					<p>Handles initial <em>incomeing</em> message verification,
					ensureing that every message is <em>symanticly</em> valid.</p>
					<dl class="tsd-comment-tags">
						<dt>param</dt>
						<dd><p>The socket to the server.</p>
						</dd>
						<dt>param</dt>
						<dd><p>The game instance for refrence.</p>
						</dd>
					</dl>
				</div>
			</section>
			<section class="tsd-panel tsd-hierarchy">
				<h3>Hierarchy</h3>
				<ul class="tsd-hierarchy">
					<li>
						<span class="target">ClientServerInterface</span>
					</li>
				</ul>
			</section>
			<section class="tsd-panel-group tsd-index-group">
				<h2>Index</h2>
				<section class="tsd-panel tsd-index-panel">
					<div class="tsd-index-content">
						<section class="tsd-index-section ">
							<h3>Constructors</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-constructor tsd-parent-kind-class"><a href="_clientserverinterface_.clientserverinterface.html#constructor" class="tsd-kind-icon">constructor</a></li>
							</ul>
						</section>
						<section class="tsd-index-section tsd-is-private-protected">
							<h3>Properties</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#game" class="tsd-kind-icon">game</a></li>
								<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#socket" class="tsd-kind-icon">socket</a></li>
							</ul>
						</section>
						<section class="tsd-index-section ">
							<h3>Methods</h3>
							<ul class="tsd-index-list">
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><a href="_clientserverinterface_.clientserverinterface.html#builtinparser" class="tsd-kind-icon">builtin<wbr>Parser</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#connect" class="tsd-kind-icon">connect</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class"><a href="_clientserverinterface_.clientserverinterface.html#connectparser" class="tsd-kind-icon">connect<wbr>Parser</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#disconnect" class="tsd-kind-icon">disconnect</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#disconnectreason" class="tsd-kind-icon">disconnect<wbr>Reason</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#isonline" class="tsd-kind-icon">is<wbr>Online</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#isroom" class="tsd-kind-icon">is<wbr>Room</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#issue" class="tsd-kind-icon">issue</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#parserversion" class="tsd-kind-icon">parser<wbr>Version</a></li>
								<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><a href="_clientserverinterface_.clientserverinterface.html#roomname" class="tsd-kind-icon">room<wbr>Name</a></li>
							</ul>
						</section>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Constructors</h2>
				<section class="tsd-panel tsd-member tsd-kind-constructor tsd-parent-kind-class">
					<a name="constructor" class="tsd-anchor"></a>
					<h3>constructor</h3>
					<ul class="tsd-signatures tsd-kind-constructor tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">new <wbr>Client<wbr>Server<wbr>Interface<span class="tsd-signature-symbol">(</span>socket<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">Socket</span>, game<span class="tsd-signature-symbol">: </span><a href="_frozen_island_.frozenislandengine.html" class="tsd-signature-type">frozenIslandEngine</a><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><a href="_clientserverinterface_.clientserverinterface.html" class="tsd-signature-type">ClientServerInterface</a></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:27</li>
								</ul>
							</aside>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5>socket: <span class="tsd-signature-type">Socket</span></h5>
								</li>
								<li>
									<h5>game: <a href="_frozen_island_.frozenislandengine.html" class="tsd-signature-type">frozenIslandEngine</a></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <a href="_clientserverinterface_.clientserverinterface.html" class="tsd-signature-type">ClientServerInterface</a></h4>
						</li>
					</ul>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group tsd-is-private-protected">
				<h2>Properties</h2>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class tsd-is-protected">
					<a name="game" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> game</h3>
					<div class="tsd-signature tsd-kind-icon">game<span class="tsd-signature-symbol">:</span> <a href="_frozen_island_.frozenislandengine.html" class="tsd-signature-type">frozenIslandEngine</a></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in clientServerInterface.ts:27</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>The game engine.
								(Because we need to check the current scene,
							and trigger events on the server.)</p>
						</div>
					</div>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-property tsd-parent-kind-class tsd-is-protected">
					<a name="socket" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> socket</h3>
					<div class="tsd-signature tsd-kind-icon">socket<span class="tsd-signature-symbol">:</span> <span class="tsd-signature-type">Socket</span></div>
					<aside class="tsd-sources">
						<ul>
							<li>Defined in clientServerInterface.ts:21</li>
						</ul>
					</aside>
					<div class="tsd-comment tsd-typography">
						<div class="lead">
							<p>The socket to the server.</p>
						</div>
					</div>
				</section>
			</section>
			<section class="tsd-panel-group tsd-member-group ">
				<h2>Methods</h2>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-private">
					<a name="builtinparser" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagPrivate">Private</span> builtin<wbr>Parser</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-private">
						<li class="tsd-signature tsd-kind-icon">builtin<wbr>Parser<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">void</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:66</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Adds in builtin message handeling events.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">void</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="connect" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> connect</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">connect<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">void</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:82</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p><code>connect</code> event handeling.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">void</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class">
					<a name="connectparser" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagAbstract">Abstract</span> connect<wbr>Parser</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class">
						<li class="tsd-signature tsd-kind-icon">connect<wbr>Parser<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">void</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:77</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Custom game event handeling.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">void</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="disconnect" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> disconnect</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">disconnect<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">void</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:128</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p><code>disconnect</code> event handeling.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">void</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="disconnectreason" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> disconnect<wbr>Reason</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">disconnect<wbr>Reason<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">...</span>args<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">[]</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">void</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:116</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p><code>disconnectReason</code> event handeling.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5><span class="tsd-flag ts-flagRest">Rest</span> <span class="tsd-signature-symbol">...</span>args: <span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">[]</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">void</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="isonline" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> is<wbr>Online</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">is<wbr>Online<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">boolean</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:39</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Identifies if the scene is online or not.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">boolean</span></h4>
							<p>true if scene has online methods.</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="isroom" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> is<wbr>Room</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">is<wbr>Room<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">boolean</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:47</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Identifies if the scene is a room or not.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">boolean</span></h4>
							<p>true if scene is a room</p>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="issue" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> issue</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">issue<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">...</span>args<span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">[]</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">void</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:90</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p><code>issue</code> event handeling.</p>
								</div>
							</div>
							<h4 class="tsd-parameters-title">Parameters</h4>
							<ul class="tsd-parameters">
								<li>
									<h5><span class="tsd-flag ts-flagRest">Rest</span> <span class="tsd-signature-symbol">...</span>args: <span class="tsd-signature-type">any</span><span class="tsd-signature-symbol">[]</span></h5>
								</li>
							</ul>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">void</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="parserversion" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> <span class="tsd-flag ts-flagAbstract">Abstract</span> parser<wbr>Version</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">parser<wbr>Version<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">number</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:136</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>returns the parserVersion number. (Used for debugging.)</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">number</span></h4>
						</li>
					</ul>
				</section>
				<section class="tsd-panel tsd-member tsd-kind-method tsd-parent-kind-class tsd-is-protected">
					<a name="roomname" class="tsd-anchor"></a>
					<h3><span class="tsd-flag ts-flagProtected">Protected</span> room<wbr>Name</h3>
					<ul class="tsd-signatures tsd-kind-method tsd-parent-kind-class tsd-is-protected">
						<li class="tsd-signature tsd-kind-icon">room<wbr>Name<span class="tsd-signature-symbol">(</span><span class="tsd-signature-symbol">)</span><span class="tsd-signature-symbol">: </span><span class="tsd-signature-type">string</span><span class="tsd-signature-symbol"> | </span><span class="tsd-signature-type">null</span></li>
					</ul>
					<ul class="tsd-descriptions">
						<li class="tsd-description">
							<aside class="tsd-sources">
								<ul>
									<li>Defined in clientServerInterface.ts:55</li>
								</ul>
							</aside>
							<div class="tsd-comment tsd-typography">
								<div class="lead">
									<p>Returns the room name or null if scene is not a room.</p>
								</div>
							</div>
							<h4 class="tsd-returns-title">Returns <span class="tsd-signature-type">string</span>
								<span class="tsd-signature-symbol"> | </span>
								<span class="tsd-signature-type">null</span>
							</h4>
							<p>room name or null</p>
						</li>
					</ul>
				</section>
			</section>
		</div>
		<div class="col-4 col-menu menu-sticky-wrap menu-highlight">
			<nav class="tsd-navigation primary">
				<ul>
					<li class="globals  ">
						<a href="../globals.html"><em>Globals</em></a>
					</li>
					<li class="current tsd-kind-external-module">
						<a href="../modules/_clientserverinterface_.html">"client<wbr>Server<wbr>Interface"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_frozen_island_.html">"frozen-<wbr>island"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_roomconstructorinterface_.html">"room<wbr>Constructor<wbr>Interface"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_base_.html">"scene/<wbr>Base"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_baseonline_.html">"scene/<wbr>Base<wbr>Online"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_connecting_.html">"scene/<wbr>Connecting"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_error_.html">"scene/<wbr>Error"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_loading_.html">"scene/<wbr>Loading"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_login_.html">"scene/<wbr>Login"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_offlinemenu_.html">"scene/<wbr>Offline<wbr>Menu"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_onlinemenu_.html">"scene/<wbr>Online<wbr>Menu"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_room_.html">"scene/<wbr>Room"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_scenetypeguard_.html">"scene/<wbr>Scene<wbr>Type<wbr>Guard"</a>
					</li>
					<li class=" tsd-kind-external-module">
						<a href="../modules/_scene_scenetypes_.html">"scene/<wbr>Scene<wbr>Types"</a>
					</li>
				</ul>
			</nav>
			<nav class="tsd-navigation secondary menu-sticky">
				<ul class="before-current">
				</ul>
				<ul class="current">
					<li class="current tsd-kind-class tsd-parent-kind-external-module">
						<a href="_clientserverinterface_.clientserverinterface.html" class="tsd-kind-icon">Client<wbr>Server<wbr>Interface</a>
						<ul>
							<li class=" tsd-kind-constructor tsd-parent-kind-class">
								<a href="_clientserverinterface_.clientserverinterface.html#constructor" class="tsd-kind-icon">constructor</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#game" class="tsd-kind-icon">game</a>
							</li>
							<li class=" tsd-kind-property tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#socket" class="tsd-kind-icon">socket</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-private">
								<a href="_clientserverinterface_.clientserverinterface.html#builtinparser" class="tsd-kind-icon">builtin<wbr>Parser</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#connect" class="tsd-kind-icon">connect</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class">
								<a href="_clientserverinterface_.clientserverinterface.html#connectparser" class="tsd-kind-icon">connect<wbr>Parser</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#disconnect" class="tsd-kind-icon">disconnect</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#disconnectreason" class="tsd-kind-icon">disconnect<wbr>Reason</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#isonline" class="tsd-kind-icon">is<wbr>Online</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#isroom" class="tsd-kind-icon">is<wbr>Room</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#issue" class="tsd-kind-icon">issue</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#parserversion" class="tsd-kind-icon">parser<wbr>Version</a>
							</li>
							<li class=" tsd-kind-method tsd-parent-kind-class tsd-is-protected">
								<a href="_clientserverinterface_.clientserverinterface.html#roomname" class="tsd-kind-icon">room<wbr>Name</a>
							</li>
						</ul>
					</li>
				</ul>
				<ul class="after-current">
				</ul>
			</nav>
		</div>
	</div>
</div>
<footer class="with-border-bottom">
	<div class="container">
		<h2>Legend</h2>
		<div class="tsd-legend-group">
			<ul class="tsd-legend">
				<li class="tsd-kind-module"><span class="tsd-kind-icon">Module</span></li>
				<li class="tsd-kind-object-literal"><span class="tsd-kind-icon">Object literal</span></li>
				<li class="tsd-kind-variable"><span class="tsd-kind-icon">Variable</span></li>
				<li class="tsd-kind-function"><span class="tsd-kind-icon">Function</span></li>
				<li class="tsd-kind-function tsd-has-type-parameter"><span class="tsd-kind-icon">Function with type parameter</span></li>
				<li class="tsd-kind-index-signature"><span class="tsd-kind-icon">Index signature</span></li>
				<li class="tsd-kind-type-alias"><span class="tsd-kind-icon">Type alias</span></li>
				<li class="tsd-kind-type-alias tsd-has-type-parameter"><span class="tsd-kind-icon">Type alias with type parameter</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-enum"><span class="tsd-kind-icon">Enumeration</span></li>
				<li class="tsd-kind-enum-member"><span class="tsd-kind-icon">Enumeration member</span></li>
				<li class="tsd-kind-property tsd-parent-kind-enum"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-enum"><span class="tsd-kind-icon">Method</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-interface"><span class="tsd-kind-icon">Interface</span></li>
				<li class="tsd-kind-interface tsd-has-type-parameter"><span class="tsd-kind-icon">Interface with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-interface"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-interface"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-interface"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-interface"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-class"><span class="tsd-kind-icon">Class</span></li>
				<li class="tsd-kind-class tsd-has-type-parameter"><span class="tsd-kind-icon">Class with type parameter</span></li>
				<li class="tsd-kind-constructor tsd-parent-kind-class"><span class="tsd-kind-icon">Constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class"><span class="tsd-kind-icon">Property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class"><span class="tsd-kind-icon">Method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class"><span class="tsd-kind-icon">Accessor</span></li>
				<li class="tsd-kind-index-signature tsd-parent-kind-class"><span class="tsd-kind-icon">Index signature</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-constructor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited constructor</span></li>
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-inherited"><span class="tsd-kind-icon">Inherited accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-protected"><span class="tsd-kind-icon">Protected accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private property</span></li>
				<li class="tsd-kind-method tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private method</span></li>
				<li class="tsd-kind-accessor tsd-parent-kind-class tsd-is-private"><span class="tsd-kind-icon">Private accessor</span></li>
			</ul>
			<ul class="tsd-legend">
				<li class="tsd-kind-property tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static property</span></li>
				<li class="tsd-kind-call-signature tsd-parent-kind-class tsd-is-static"><span class="tsd-kind-icon">Static method</span></li>
			</ul>
		</div>
	</div>
</footer>
<div class="container tsd-generator">
	<p>Generated using <a href="https://typedoc.org/" target="_blank">TypeDoc</a></p>
</div>
<div class="overlay"></div>
<script src="../assets/js/main.js"></script>
<script>if (location.protocol == 'file:') document.write('<script src="../assets/js/search.js"><' + '/script>');</script>
</body>
</html>